/*******************************************************************************
 Module: tracking for contact status
 File: src/vagus/tracking/Tracking.java
 Version: 2.1  Date: 02-04-2009
 Author(s): Gusev Vladimir (VAGus)
 *******************************************************************************/

package jimm.modules.tracking;

import java.util.*;
import javax.microedition.rms.*;
import javax.microedition.lcdui.Font;

import DrawControls.*;
import DrawControls.icons.Icon;
import jimm.comm.*;
import jimm.chat.message.*;
import jimm.*;
import jimm.util.*;
import jimm.ui.*;
import jimm.modules.*;
import jimm.cl.*;
import protocol.*;
import protocol.*;
import protocol.icq.*;
import protocol.mrim.*;
import protocol.obimp.*;
// #sijapp cond.if protocols_JABBER is "true" #
import protocol.jabber.*;
// #sijapp cond.end #

public final class Tracking {
    //private static boolean isWorked = false;
    private final static String track_rms_name = "track";
    private static Vector actions = new Vector();
    public final static int TRACK_PARAM_COUNT = 4;
    public final static int TRACK_PARAM_UIN = 0;
    public final static int TRACK_PARAM_EVENT_ID = 1;
    public final static int TRACK_PARAM_ACTION_ID = 2;
    public final static int TRACK_PARAM_ACTION_VALUE = 3;
    
    /*public static class WorkTimer extends TimerTask {
        public void run() {
            if (!ContactList.getInstance().getManager().getCurrentProtocol().isConnected()) {
                startTrack();
            } else {
                setWorked(true);
            }
        }
    }
    
    public static void startTrack() {
        setWorked(false);
        new Timer().schedule(new WorkTimer(), 5000);
    }*/
    public static class Track {
        int idIcon;
        String uin;
        int idEvent;
        int idAction;
        String valueAction;
    }
    private static void addTracking(Track track) {
        synchronized (actions) {
            actions.addElement(track);
        }
    }
    private static Track getTracking(int index) {
        synchronized (actions) {
            return (Track)actions.elementAt(index);
        }
    }
    private static void setTracking(Track track, int index) {
        synchronized (actions) {
            actions.setElementAt(track, index);
        }
    }
    private static Track getTrackingMessageByTrackMessageText(Track track) {
        int index = findTrackingByID(track.idEvent, track.idAction);
        if (index<=0) return null;
        synchronized (actions) {
            return (Track)actions.elementAt(index-1);
        }
    }
    private static int findTrackingByID(int evt_index, int act_index) {
        int ret=-1;
        for (int i=0;i<actions.size();i++) {
            Track track = getTracking(i);
            if (track.idEvent==evt_index && track.idAction==act_index) {
                ret = i;
                break;
            }
        }
        return ret;
    }
    private static void deleteTracking(int index) {
        synchronized (actions) {
            actions.removeElementAt(index);
            actions.trimToSize();
        }
    }
    public static void addTrackList(String uin) {
        deleteTrackListFromTracking(uin);
        Vector list = TrackingForm.getList();
        if (list==null || list.size()<=0) return;
        for (int i=0;i<list.size();i++) {
            TrackingForm.Line line = (TrackingForm.Line)list.elementAt(i);
            if (line.isEvent) continue;
            if (line.status_flag==0) continue;
            Track track = new Track();
            track.idIcon = TrackingForm.TRACK;
            track.uin = uin;
            track.idEvent = line.id_event;
            track.idAction = line.id_action;
            if (line.id_action==ACTION_MESSAGE_TEXT) {
                track.valueAction=line.name;
            } else {                    
                track.valueAction="";
            }
            addTracking(track);
        }
    }
    public static Vector getTrackList(String uin) {
        if (actions==null || actions.size()==0) return null;
        Vector ret = new Vector();
        for (int i=0;i<actions.size();i++) {
            Track track = getTracking(i);
            if (!track.uin.equals(uin)) continue;
            ret.addElement(track);
        }
        return ret;
    }
    private static void deleteTrackListFromTracking(String uin) {
        for (int i=0;i<actions.size();i++) {
            Track track = getTracking(i);
            if (track.uin.equals(uin)) {
                deleteTracking(i);
                i--;
            }
        }
    }

    private static boolean existsTrackingRMS() {
        boolean ret = false;
        RecordStore rms = null;
        try {
            rms = RecordStore.openRecordStore(track_rms_name, false);
            if (rms.getNumRecords()==0) {
                ret = false;
            } else {
                ret = true;
            }
            rms.closeRecordStore();
        } catch (RecordStoreException e) {
        }
        return ret;
    }
    public static void loadTrackingFromRMS() {
        RecordStore rms = null;
        try {
            if (!existsTrackingRMS()) return;
            rms = RecordStore.openRecordStore(track_rms_name, false);
            int record_count = rms.getNumRecords();
            if (record_count==0) return;
            for (int i=1;i<=record_count;i=i+TRACK_PARAM_COUNT) {
                Track track = new Track();
                track.uin = getRMSRecordValue(rms, i+TRACK_PARAM_UIN);
                track.idEvent = Integer.parseInt(getRMSRecordValue(rms, i+TRACK_PARAM_EVENT_ID));
                track.idAction = Integer.parseInt(getRMSRecordValue(rms, i+TRACK_PARAM_ACTION_ID));
                track.valueAction = getRMSRecordValue(rms, i+TRACK_PARAM_ACTION_VALUE);
                track.idIcon = TrackingForm.TRACK;
                addTracking(track);
            }
            rms.closeRecordStore();
        } catch (RecordStoreException e) {
		//    jimm.modules.DebugLog.panic("loadTrackingFromRMS" + e);
        }
    }
    public static void saveTrackingToRMS() {
        RecordStore rms = null;
        try {
            if (existsTrackingRMS()) RecordStore.deleteRecordStore(track_rms_name);
        } 
        catch (RecordStoreException e) {
            return;
        }
        try {
            int record_count = actions.size();
            if (record_count==0) return;
            rms = RecordStore.openRecordStore(track_rms_name, true);
            for (int i=0;i<record_count;i++) { 
                Track track = getTracking(i);
                addValueToRMSRecord(rms, track.uin);
                addValueToRMSRecord(rms, String.valueOf(track.idEvent));
                addValueToRMSRecord(rms, String.valueOf(track.idAction));
                addValueToRMSRecord(rms, track.valueAction);
            }
            rms.closeRecordStore();
        } catch (RecordStoreException e) {
		//    jimm.modules.DebugLog.panic("saveTrackingToRMS" + e);
        }
    }
    private static String getRMSRecordValue(RecordStore rms, int index) {
        String ret="";
        try {
            byte[] data = rms.getRecord(index);
            if (data != null) {
                ret = StringConvertor.utf8beByteArrayToString(data, 0, data.length);
            }
        } catch (RecordStoreException e) {
        }
        return ret;
    }
    private static void addValueToRMSRecord(RecordStore rms, String value) {
        try {
            byte[] buffer;
            //buffer = StringConvertor.stringToByteArray(value);
			buffer = StringConvertor.stringToByteArrayUtf8(value);
            rms.addRecord(buffer, 0, buffer.length);
        } catch (RecordStoreException e) {
        }
    }

    /*public static boolean isWorked() {
        return isWorked;
    }
    public static void setWorked(boolean flag) {
        isWorked = flag;
    }*/
    public static boolean isTracking(String uin, int event) {
        //if (!isWorked()) return false;
        for (int i=0;i<actions.size();i++) {
            Track track = getTracking(i);
            if (!track.uin.equals(uin)) continue;
            if (track.idEvent!=event) continue;
            if (track.idAction==ACTION_MESSAGE_TEXT) continue;
            return true;
        }
        return false;
    }
    public static boolean isTracking(String uin) {
        for (int i=0;i<actions.size();i++) {
            Track track = getTracking(i);
            if (!track.uin.equals(uin)) continue;
            if (track.idAction==ACTION_MESSAGE_TEXT) continue;
            return true;
        }
        return false;
    }
    public static boolean isTracking() {
        if (actions==null || actions.size()==0) return false;
        return true;
    }
    public static Icon getTrackIcon(String uin) {
        Icon ret = null;
        for (int i=0;i<actions.size();i++) {
            Track track = getTracking(i);
            if (!track.uin.equals(uin)) continue;
            switch (track.idIcon) {
                case TrackingForm.TRACK:
                    ret = TrackingForm.getTrackIcon();
                    break;
                case TrackingForm.TRACKON:
                    ret = TrackingForm.getTrackONIcon();
                    break;
                case TrackingForm.TRACKOFF:
                    ret = TrackingForm.getTrackOFFIcon();
                    break;
                case TrackingForm.TRACKONOFF:
                    ret = TrackingForm.getTrackONOFFIcon();
                    break;
            }
            break;
        }
        return ret;
    }
    public static void setTrackIcon(String uin, int icon_index) {
        for (int i=0;i<actions.size();i++) {
            Track track = getTracking(i);
            if (!track.uin.equals(uin)) continue;
            track.idIcon = icon_index;
            setTracking(track, i);
        }
    }

    public final static int EVENT_ENTER = 0;
   /* public final static int EVENT_EXIT = 1;
    public final static int EVENT_STATUS = 2;
    public final static int EVENT_MESSAGE = 3;
    public final static int EVENT_TYPING = 4;
    public final static int EVENT_XSTATUS = 5;*/
    
    public final static int ACTION_CHAT = 10;
   /* public final static int ACTION_NOTICE = 11;
    public final static int ACTION_SOUND = 12;
    // #sijapp cond.if modules_MAGIC_EYE is "true" #
    public final static int ACTION_EYE = 13;
    // #sijapp cond.end#
    public final static int ACTION_VIBRA = 14;
    public final static int ACTION_MESSAGE = 15;*/
    public final static int ACTION_MESSAGE_TEXT = 16;
  //  public final static int ACTION_ICON = 17;
  //  public final static int ACTION_INCHAT = 18;
	
	public final static int ACTION_HISTORY = 19;

    public static void beginTrackAction(Contact item, int event) {
        for (int i=0;i<actions.size();i++) {
            Track track = getTracking(i);
            if (!track.uin.equals(item.getUserId())) continue;
        /*     if (event!=EVENT_XSTATUS) {
               if (track.idEvent!=event) continue;
            } else {
               if (track.idEvent!=EVENT_STATUS) continue;
            }*/
            int action = track.idAction;
            if (event==EVENT_ENTER) {
                beginTrackActionEnter(item, action, track);
            }
           /* if (event==EVENT_EXIT) {
                beginTrackActionExit(item, action);
            }
            if (event==EVENT_STATUS || event==EVENT_XSTATUS) {
                beginTrackActionStatus(item, event, action);
            }*/
           /* if (event==EVENT_MESSAGE) {
                beginTrackActionMessage(item, action);
            }*/
           /* if (event==EVENT_TYPING) {
                beginTrackActionTyping(item, action);
            }*/
        }
    }
	//public static boolean isHistory = false;
	public static boolean isHistory(Contact item) {
	    return item.history;
	}
	public static boolean isPresence(Contact item) {
	    return item.presence;
	}
    private static void beginTrackActionEnter(Contact item, int action, Track track) {
        //Protocol protocol = item.getProtocol();
		item.history = false;
		item.presence = false;
        switch (action) {
	        case ACTION_HISTORY:
			//if (item.getProtocol().getContactList().getCurrentContact() == item) {
			    item.history = true;
			//}
			    break;
            case ACTION_CHAT:
			    item.presence = true;
                //protocol.getChat(item).activate();
                break;
           /* case ACTION_NOTICE:
                new PopupWindow(JLocale.getString("track_form_title")+" "+item.getName(), item.getName()+" ["+item.getUserId()+"] "+JLocale.getString("track_action_online"), 5000).show();
                break;
            case ACTION_INCHAT:
                String notice = JLocale.getString("track_action_online");
                PlainMessage plainMsg = new PlainMessage(item.getUserId(), protocol, Util.createCurrentDate(false), notice, true);
                plainMsg.setSendingState(Message.ICON_MSG_TRACK);
                protocol.getChat(item).addMyMessage(plainMsg);
                break;
            case ACTION_SOUND:
                Notify.getSound().playSoundNotification(Notify.SOUND_TYPE_TRACK_ENTER);  
                break;
            case ACTION_VIBRA:
                vibration();
                break;
            case ACTION_ICON:
                setTrackIcon(item.getUserId(), TrackingForm.TRACKON);
                break;
// #sijapp cond.if modules_MAGIC_EYE is "true" #
            case ACTION_EYE:
                MagicEye.addAction(item.getProtocol(), item.getUserId(), JLocale.getString("track_action_online"));
                break;
// #sijapp cond.end#
            case ACTION_MESSAGE_TEXT:
                Track track_prev = getTrackingMessageByTrackMessageText(track);
                if (track_prev!=null) {
                    if (track_prev.idAction==ACTION_MESSAGE) {
                        String str = track.valueAction;
                        if (str.length()!=0) ContactList.getInstance().getManager().getCurrentProtocol().sendMessage(item, str, true);
                    }
                }
                break;*/
        }
		//jimm.modules.DebugLog.println(item.getUserId() + " " + item.history);
    }
    /*private static void beginTrackActionExit(Contact item, int action) {
        Protocol protocol = item.getProtocol();
        switch (action) {
            case ACTION_NOTICE:
                new PopupWindow(JLocale.getString("track_form_title")+" "+item.getName(), item.getName()+" ["+item.getUserId()+"] "+JLocale.getString("track_action_offline"), 5000).show();
                break;
            case ACTION_INCHAT:
                String notice = JLocale.getString("track_action_offline");
                PlainMessage plainMsg = new PlainMessage(item.getUserId(), protocol, Util.createCurrentDate(false), notice, true);
                plainMsg.setSendingState(Message.ICON_MSG_TRACK);
                protocol.getChat(item).addMyMessage(plainMsg);
                break;
            case ACTION_SOUND:
                Notify.getSound().playSoundNotification(Notify.SOUND_TYPE_TRACK_EXIT);  
                break;
            case ACTION_ICON:
                setTrackIcon(item.getUserId(), TrackingForm.TRACKOFF);
                break;
            case ACTION_VIBRA:
                vibration();
                break;
// #sijapp cond.if modules_MAGIC_EYE is "true" #
            case ACTION_EYE:
                MagicEye.addAction(item.getProtocol(), item.getUserId(), JLocale.getString("track_action_offline"));
                break;
// #sijapp cond.end#
        }
    }
    /* private static void beginTrackActionStatus(Contact item, int event, int action) {
        String status_name = "Not defined";
        String status_comm = "";
        String xstatus = status_name;
        Icon icon_status = null;
        Protocol protocol = item.getProtocol();
        if (protocol instanceof Icq) {
            if (event == EVENT_STATUS) {
                status_comm = JLocale.getString("track_action_status")+" ";
                icon_status = ((IcqContact)item).getStatusGraphicsEx.getIcon();
                status_name = " ["+((IcqContact)item).getStatusGraphicsEx.getName()+"]";
            }
// #sijapp cond.if modules_XSTATUSES is "true" #
            if (event == EVENT_XSTATUS) {
                status_comm = JLocale.getString("track_action_xstatus")+" ";
                icon_status = ((IcqContact)item).getXStatusGraphicsEx.getStatusIcon();
                status_name = " ["+((IcqContact)item).getXStatusGraphicsEx.getXStatusAsString()+"]";
            }
// #sijapp cond.end#
        }
        // #sijapp cond.if protocols_MRIM is "true" #
        if (protocol instanceof Mrim) {
           if (event == EVENT_STATUS) {
               status_comm = JLocale.getString("track_action_status")+" ";
               icon_status = ((MrimContact)item).getStatusGraphicsEx.getIcon();
               status_name = " ["+((MrimContact)item).getStatusGraphicsEx.getName()+"]";
            }
// #sijapp cond.if modules_XSTATUSES is "true" #
            if (event == EVENT_XSTATUS) {
                status_comm = JLocale.getString("track_action_xstatus")+" ";
                icon_status = ((MrimContact)item).getXStatusGraphicsEx.getIcon();
                status_name = " ["+((MrimContact)item).getXStatusGraphicsEx.getName()+"]";
            }
// #sijapp cond.end#
        }
         // #sijapp cond.end#
        switch (action) {
            case ACTION_INCHAT:
                PlainMessage plainMsg = new PlainMessage(item.getUserId(), protocol, Util.createCurrentDate(false), status_comm, true);
                plainMsg.setSendingState(Message.ICON_MSG_TRACK);
                plainMsg.setStatusIcon(icon_status);
                plainMsg.setStatusName(status_name);
                protocol.getChat(item).addMyMessage(plainMsg);
                break;
            case ACTION_SOUND:
                Notify.getSound().playSoundNotification(Notify.SOUND_TYPE_TRACK_STATUS);  
                break;
            case ACTION_ICON:
                setTrackIcon(item.getUserId(), TrackingForm.TRACKONOFF);
                break;
            case ACTION_VIBRA:
                vibration();
                break;
// #sijapp cond.if modules_MAGIC_EYE is "true" #
            case ACTION_EYE:
                MagicEye.addAction(protocol, item.getUserId(), status_name, status_comm, icon_status);
                break;
// #sijapp cond.end#
        }
    }
    private static void beginTrackActionMessage(Contact item, int action) {
        switch (action) {
            case ACTION_VIBRA:
                vibration();
                break;
            case ACTION_SOUND:
                Notify.getSound().playSoundNotification(Notify.SOUND_TYPE_TRACK_MESSAGE);  
                break;
        }
    }
    private static void beginTrackActionTyping(Contact item, int action) {
        switch (action) {
            case ACTION_VIBRA:
                vibration();
                break;
            case ACTION_SOUND:
                Notify.getSound().playSoundNotification(Notify.SOUND_TYPE_TRACK_TYPING);  
                break;
        }
    }
    private static void vibration() {
        Notify.getSound().vibrate(500);
    }*/
}